enemy = {}

function enemy.load()
  enemy.bulletImage1 = love.graphics.newImage("sprites/enemybullet1.png")
  enemy.bulletImage2 = love.graphics.newImage("sprites/enemybullet2.png")
  enemy.topImage = love.graphics.newImage("sprites/enemytop.png")
  enemy.topImage2 = love.graphics.newImage("sprites/enemytop2.png")
  enemy.middleImage = love.graphics.newImage("sprites/enemymiddle.png")
  enemy.middleImage2 = love.graphics.newImage("sprites/enemymiddle2.png")
  enemy.bottomImage = love.graphics.newImage("sprites/enemybottom.png")
  enemy.bottomImage2 = love.graphics.newImage("sprites/enemybottom2.png")
  enemy.deadImage = love.graphics.newImage("sprites/enemydead.png")

  enemy.currentImage = 1

  enemy.timerMax = 55
  enemy.timer = enemy.timerMax
  enemy.speed = 20
  enemy.moveCount = 0
  enemy.originalMaxMoveCount = 7
  enemy.maxMoveCount = enemy.originalMaxMoveCount

  enemy.enemies = {}
  enemy.bullets = {}
  EnemyXCount = 1
  EnemyYCount = 1

  enemy.shootTime = love.math.random(5, 10)

  generated = false
end

function enemy.update(dt)
  if #enemy.enemies > 20 then
    enemy.timerMax = #enemy.enemies
  end
  enemy.timer = enemy.timer - 1

-- Enemy Creation
  if #enemy.enemies <= 5 and generated == false then
    for i = 1,55 do
      newEnemy = {}
      newEnemy.x = (32 * EnemyXCount) - 20
      newEnemy.y = 32 + (32 * EnemyYCount)
      newEnemy.dead = false

      if i < 12 then
        newEnemy.x = newEnemy.x + 3
        newEnemy.image = enemy.topImage
        newEnemy.image2 = enemy.topImage2
        newEnemy.scoreValue = 30
      elseif i < 34 then
        newEnemy.image = enemy.middleImage
        newEnemy.image2 = enemy.middleImage2
        newEnemy.scoreValue = 20
      elseif i < 56 then
        newEnemy.image = enemy.bottomImage
        newEnemy.image2 = enemy.bottomImage2
        newEnemy.scoreValue = 10
      end

      newEnemy.imagec = newEnemy.image

      if i % 11 == 0 and i ~= 1 then
        EnemyXCount = 1
        EnemyYCount = EnemyYCount + 1
      else
        EnemyXCount = EnemyXCount + 1
      end
      table.insert(enemy.enemies, newEnemy)
    end
    generated = true
  end

-- Enemy Movement
  if enemy.timer < 1 then
    for i,e in ipairs(enemy.enemies) do
      if enemy.moveCount < enemy.maxMoveCount then
        e.x = e.x + enemy.speed
        if enemy.maxMoveCount > enemy.originalMaxMoveCount then
          enemy.maxMoveCount = enemy.maxMoveCount - 1
        end
      end
      enemy.timer = enemy.timerMax
      if enemy.moveCount >= enemy.maxMoveCount then
        if enemy.speed > 0 then
          e.y = e.y + enemy.speed
        else
          e.y = e.y + enemy.speed * -1
        end
      end
    end
    if enemy.moveCount >= enemy.maxMoveCount then
      enemy.maxMoveCount = enemy.maxMoveCount + 1
      enemy.speed = enemy.speed * -1
      enemy.moveCount = 0
    end
    enemy.moveCount = enemy.moveCount + 1
    enemy.currentImage = enemy.currentImage + 1
  end

-- Animate enemies
  for i,e in ipairs(enemy.enemies) do
    if enemy.currentImage % 2 == 0 and e.dead == false then
      e.imagec = e.image2
    else
      e.imagec = e.image
    end
  end

-- Handle enemie shooting
  enemy.shootTime = enemy.shootTime - 1 * dt
  if enemy.shootTime < 0 then
    enemy.canShoot = true
  end

  if enemy.canShoot == true then
    newEnemyBullet = {}
    enemy.randomNumber = love.math.random(0, 11)
    newEnemyBullet.x = enemy.enemies[enemy.randomNumber].x
    newEnemyBullet.y = enemy.enemies[#enemy.enemies].y + 16
    newEnemyBullet.speed = 500

    newEnemyBullet.image = enemy.bulletImage1
    newEnemyBullet.image2 = enemy.bulletImage2
    newEnemyBullet.imagec = newEnemyBullet.image

    table.insert(enemy.bullets, newEnemyBullet)

    enemy.canShoot = false
    enemy.shootTime = love.math.random(1, 5)
  end

  for i,b in ipairs(enemy.bullets) do
    b.y = b.y + b.speed * dt

    if b.y > love.graphics.getHeight() then
      table.remove(enemy.bullets, i)
    end
  end

  for i,b in ipairs(enemy.bullets) do
    if b.imagec == b.image then
      b.imagec = b.image2
    else
      b.imagec = b.image
    end
  end
end

function enemy.draw()
  for i, e in ipairs(enemy.enemies) do
    love.graphics.draw(e.imagec, e.x, e.y, 0, 2, 2)
  end
  for i, b in ipairs(enemy.bullets) do
    love.graphics.draw(b.imagec, b.x, b.y, 0, 2, 2)
  end
end
