require "lovedebug"

require "ufo"
require "enemy"
require "player"
require "barrier"

function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function love.load()
  font = love.graphics.newFont("sprites/ca.ttf", 24)
  love.graphics.setDefaultFilter("nearest", "nearest")

  score = 0
  screen = "game"
  level = 1

  ufoCollided = false

  deathTimer = 0
  startTimer = false

  ufo.load()
  barrier.load()
  enemy.load()
  player.load()deadEnemies = {}
end

function love.update(dt)
  if screen == "game" then
    ufo.update(dt)
    barrier.update(dt)
    enemy.update(dt)
    player.update(dt)

-- Check Player Bullet Enemy Collision
    for i = table.getn(enemy.enemies), 1, -1 do
      local e = enemy.enemies[i]
      for j,b in ipairs(player.bullets) do
        if CheckCollision(e.x, e.y, 12 * 4, 8 * 4, b.x, b.y, 4, 16) then
          e.dead = true
          e.image = enemy.deadImage
          table.remove(player.bullets, j)
          score = score + e.scoreValue
          startTimer = true
        end
      end
    end

    for i = table.getn(enemy.enemies), 1, -1 do
      local e = enemy.enemies[i]
      if e.dead == true and deathTimer > .1 then
        table.remove(enemy.enemies, i)
        deathTimer = 0
        startTimer = false
      end
    end

    if startTimer == true then
      deathTimer = deathTimer + dt
    end

-- Check Player UFO Collision
  for i,b in ipairs(player.bullets) do
    if CheckCollision(ufo.x, ufo.y, 32, 14, b.x, b.y, 4, 16) then
      if ufoCollided == false then
        ufo.dead = true
        randomScore = love.math.random(1, #ufo.scoreValue)
        score = score + ufo.scoreValue[randomScore]
        ufo.x = 0
        ufoCollided = true
      end
    end
  end

  if ufo.timer <= 5 and ufoCollided == true then
    ufoCollided = false
  end

-- Check Enemy Bullet Player Collision
  for i,b in ipairs(enemy.bullets) do
    if CheckCollision(player.x, player.y, player.image:getWidth() * player.sx, player.image:getHeight() * player.sy, b.x, b.y, 12, 28) then
      player.lives = player.lives - 1
      table.remove(enemy.bullets, i)
      player.dead = true
    end
  end

-- Check Enemy Bottom Collision
    if enemy.enemies[#enemy.enemies].y == player.y then
      screen = "gameover"
    end

    if #enemy.enemies == 0 then
      level = level + 1
      lives = 3
    end
  end



  if screen == "gameover" then
  end
end

function love.draw()
  if screen == "game" then
    ufo.draw()
    barrier.draw()
    enemy.draw()
    player.draw()
    love.graphics.setFont(font)
    love.graphics.print("Score:", 340, 5)
    love.graphics.print(score, 450, 5)
  end
  if screen == "gamover" then
  end
end
