player = {}

function player.load()
  player.image = love.graphics.newImage('sprites/player.png')
  bulletImg = love.graphics.newImage('sprites/playerbullet.png')
  player.deadImage = love.graphics.newImage('sprites/playerdead.png')
  player.deadImage2 = love.graphics.newImage('sprites/playerdead2.png')
  player.currentDeathImage = player.deadImage

  player.x = 50
  player.y = 550

  player.sx = 2
  player.sy = 2

  player.speed = 350
  bulletSpeed = 250

  shoot = true
  shootTimerMax = 1
  shootTimer = shootTimerMax

  player.lives = 3
  player.dead = false
  player.deadTimer = 0
  player.deadAnimTimer = 0

  player.bullets = {}
end

function player.update(dt)
  -- Player movement
  if love.keyboard.isDown('left', 'a') and player.x > 0 and player.dead == false then
    player.x = player.x - player.speed * dt
  end

  if love.keyboard.isDown('right', 'd') and player.x + (player.image:getWidth() * player.sx) < love.graphics.getWidth() and player.dead == false then
    player.x = player.x + player.speed * dt
  end

  -- Handle bullets
  shootTimer = shootTimer - 1 * dt
  if shootTimer < 0 then
    shoot = true
  end

  if love.keyboard.isDown(' ') and shoot and player.dead == false then
    newBullet = {}

    newBullet.x = player.x + (((player.image:getWidth() * player.sx)/2)-2)
    newBullet.y = player.y

    newBullet.image = bulletImg

    table.insert(player.bullets, newBullet)

    shoot = false
    shootTimer = shootTimerMax
  end

  for i, bullet in ipairs(player.bullets) do
    bullet.y = bullet.y - bulletSpeed * dt

    if bullet.y < 0 then
      table.remove(player.bullets, i)
    end
  end

  if player.dead == true then
    player.deadTimer = player.deadTimer + dt
    player.deadAnimTimer = player.deadAnimTimer + dt
  end
end

function player.draw()
  if player.dead == true then
    love.graphics.draw(player.currentDeathImage, player.x, player.y, 0, player.sx, player.sy)

    if player.currentDeathImage == player.deadImage and player.deadAnimTimer > .1 then
      player.currentDeathImage = player.deadImage2
      player.deadAnimTimer = 0
    elseif player.deadAnimTimer > .2 then
      player.currentDeathImage = player.deadImage
      player.deadAnimTimer = 0
    end

    if player.deadTimer > 3 then
      player.deadTimer = 0
      player.dead = false
    end
  else
    love.graphics.draw(player.image, player.x, player.y, 0, player.sx, player.sy)
  end

  for i, bullet in ipairs(player.bullets) do
    love.graphics.draw(bullet.image, bullet.x, bullet.y, 0, player.sx, player.sy)
  end

  for i = 1, player.lives do
    love.graphics.draw(player.image, 0 + (i * 20), 5)
  end
end
